PostgreSQL 7.1.3 Documentation
Prev |  | Next

# SPI_saveplan

## Name

SPI_saveplan -- Saves a passed plan

## Synopsis

    SPI_saveplan(plan)

### Inputs

void *`query`

  Passed plan

### Outputs

void *

  Execution plan location. NULL if unsuccessful.

SPI_result

  SPI_ERROR_ARGUMENT if plan is NULL
  SPI_ERROR_UNCONNECTED if procedure is un-connected

## Description

`SPI_saveplan` stores a plan prepared by `SPI_prepare` in safe memory protected from freeing by `SPI_finish` or the transaction manager.

In the current version of Postgres there is no ability to store prepared plans in the system catalog and fetch them from there for execution. This will be implemented in future versions. As an alternative, there is the ability to reuse prepared plans in the consequent invocations of your procedure in the current session. Use `SPI_execp` to execute this saved plan.

## Usage

`SPI_saveplan` saves a passed plan (prepared by `SPI_prepare`) in memory protected from freeing by `SPI_finish` and by the transaction manager and returns a pointer to the saved plan. You may save the pointer returned in a local variable. Always check if this pointer is NULL or not either when preparing a plan or using an already prepared plan in SPI_execp (see below).

> Note: If one of the objects (a relation, function, etc.) referenced by the prepared plan is dropped during your session (by your backend or another process) then the results of `SPI_execp` for this plan will be unpredictable.

Prev | Home | Next
SPI_prepare | Up | SPI_execp